
# Lesson 1 - Introduction to Python. 
# Topics - Importing modules and their purpose, Simple Mathematical Functions
# Vectors and Indexing, Simple For Cycles, Iterative Functions and Plotting with Matplotlib

#import numpy as np
from numpy import sin, cos, pi, dot, zeros, ones, loadtxt, savetxt
from numpy.random import randn
from matplotlib.pyplot import figure, subplot, plot, grid, xlabel, ylabel, title, show

# Function 1

t = range(0,10)
y = sin(t) + randn(1)*0.5

print y

#figure()
#subplot(211)
#plot(t,'k'), grid()
#subplot(212)
#plot(t,y), title('y=F(t)'),grid()
#show()

#Simple Mathematical Functions 

#x=2
#y2 = x**3 + 6*x**2 + 1
#y2 = exp(x)
#y2 = sqrt(x)+3

#print y2

# Matrices and Vectors + For cycle

a = [2,4,5,6,7]
#a = range(0,10) # To generate a sequence of asending numbers within a certain range
#print a

# Vector/Matrices Indexing

#a[-1] # Returns the last value of the Vector a
#a[-2] # Returns the 2nd last value of the Vector a etc.
#a[0] # Returns the 1st value of the Vector a. Python begins with 0 as the first element!
#a[:-2] # Returns all values of the Vector a. before the 2nd last element 
#a[-2:] # Returns all values of the Vector a. after the 2nd last element 
#print shape(a) # Prints the dimensions of vector a
#print len(a) # Prints the length of the vector a

# Simple For cycles 


for k in range(0,5):
    b = dot(a,2)

print b 

x = range(0,10)
y2 = zeros(len(x))

for k in range(0,len(x)):
    y2[k] = x[k]**3 - 6*(x[k]**2) + 1

print y2

# Loading and saving data simply with Numpy
# We may also load data measured from an engineering process
# Or save newly calculated values from our algorithm.

#x = loadtxt('x.txt')
#y = savetxt('y.txt',y2)

figure()
subplot(211)
plot(t,y,'k'), title('F(x)'), grid()
subplot(212)
plot(y2,'g'),title('F(x)'), grid()
show()