
from numpy import sin, cos 

# Python is based on "Object-oriented programming technique. All modules require
# classes and functions in order for you to re use them with your own user defined
# variables. A class = template of an Object(also known as the instance of the class (i.e; Student)). 
# The attributes = Characteristics
# i.e; the student has: name, gender, ID, grades, attendance
# The method/functions of the class help us compute/define what the values of
# these characteristics/attributes are i.e; def addGrade etc.

class Student():
# Here we always list the constructor line to initiate the "constructor method"
# associated with this style of Object-Oriented Programming
    def __init__(self,name): # Here all parameters neccesary for the attributes are listed
# Here we list all attributes
        self.name = name
        self.attendance = 0
        self.grades = []

# Here we list all methods or functions that calculate or define the attributes
        
    def addGrade(self, grade):
        self.grades.append(grade)
        
    def addAttendance(self):
        self.attendance += 1
        
    def getAverage(self):
        return sum(self.grades) / len(self.grades)

# Example of a class of mathematical functions i.e; sinx is an instance in the 
# class of Mathematical Functions. Its method of the instance sinx must return
# the calculation of sinx for a user defined variable.
        
class Functions():
    def __init__(self,name):
        self.name = name
        self.sinx = []
        self.cosx = []
        
    def addSinx(self,x):
        y = sin(x)
        self.sinx.append(y)
        
    def addCosx(self,x):
        self.cosx.append(cos(x))

