
from numpy import *
from matplotlib.pyplot import *

#Iterative function block example

x = [1,2,3,4,5]

def yout(x):
    y = zeros(len(x))    
    for k in range(0,len(x)):
        y[k]=2*x[k]
    return y
    
print yout(x)


#Task3: Define two function blocks "sinus" and "cosine" and run these function
#blocks through another function block "visualise" which plots the corresponding 
#results.

def sinus(w,t):    
    omega = w
    N = len(t)
    y1 = zeros(N)      
    for k in range(0,N):
        y1[k] = sin(omega*t[k])
    return y1

def cosine(w,t):    
    omega = w
    N = len(t)    
    y2 = zeros(N)      
    for k in range(0,N):
        y2[k] = cos(omega*t[k])
    return y2   
    
def visualise(x,y):    
    figure()
    subplot(211)
    plot(x),grid
    subplot(212)
    plot(y),grid
    show()

# using our defined functions
w = 0.25*pi     
t = linspace(0,100,100)

function1_sin = sinus(w,t)
function2_cos = cosine(w,t)

# Running through visualisation function
visualise(function1_sin,function2_cos)