import RPi.GPIO as GPIO
import glob
import time

# Use BCM GPIO references
GPIO.setmode(GPIO.BCM)

GPIO_In = 23
## GPIO 4 = Pin 16

# Set pins as input
GPIO.setup(GPIO_In,GPIO.IN)
GPIO.add_event_detect(GPIO_In, GPIO.BOTH)

deg=0
f = open('deg.txt','w')

try:
    while True:
        if GPIO.event_detected(GPIO_In):
            deg -= 6
            t=time.time()
            f.write('{} {}\n' .format(deg,t))
            print deg,t
            
except KeyboardInterrupt:
    GPIO.cleanup()
    f.close()

